/* This table represents data which shouldn't overlap but does.*/
create table #Data
(
 Id int identity(1,1),
 Person int,
 BeginValue int,
 EndValue int
);

insert into #Data(Person, BeginValue, EndValue) values(1, 1, 5);
insert into #Data(Person, BeginValue, EndValue) values(1, 2, 7);
insert into #Data(Person, BeginValue, EndValue) values(1, 2, 2);	/* Same-day...and already covered */
insert into #Data(Person, BeginValue, EndValue) values(1, 2, 14);	/* Overlaps with 1-5 and 2-7 */
insert into #Data(Person, BeginValue, EndValue) values(1, 9, 13);	/* Overlaps with 2-14 */
insert into #Data(Person, BeginValue, EndValue) values(1, 14, 17);	/* Overlaps with 2-14 */
insert into #Data(Person, BeginValue, EndValue) values(1, 16, 20);	/* Overlaps with 14-17 */
insert into #Data(Person, BeginValue, EndValue) values(1, 20, 20);	/* Same-day...and already covered */
insert into #Data(Person, BeginValue, EndValue) values(2, 1, 5);
insert into #Data(Person, BeginValue, EndValue) values(2, 6, 8);
insert into #Data(Person, BeginValue, EndValue) values(2, 9, 15);
insert into #Data(Person, BeginValue, EndValue) values(2, 15, 15);	/* Same-day...and already covered */
insert into #Data(Person, BeginValue, EndValue) values(2, 16, 20);
insert into #Data(Person, BeginValue, EndValue) values(2, 21, 25);
insert into #Data(Person, BeginValue, EndValue) values(3, 1, 5);
insert into #Data(Person, BeginValue, EndValue) values(4, 2, 2);
insert into #Data(Person, BeginValue, EndValue) values(5, 1, 5);
insert into #Data(Person, BeginValue, EndValue) values(5, 6, 10);
insert into #Data(Person, BeginValue, EndValue) values(6, 1, 5);
   
with records as
(
	select
		Person,
		FirstId as Id,
		MIN(N) as NewBeginValue,
		MAX(N) as NewEndValue
	from
	(
		select
			t.N,
			d.Person,
			MIN(d.Id) as FirstId
		from
			#Data d
			inner join dbo.Tally t
				on t.N between d.BeginValue and d.EndValue
		group by
			t.N,
			d.Person
	) arrangements
	group by
		Person,
		FirstId
)
select *
from
   #Data d
   inner join records r on d.Id = r.Id
order by
   d.Person;
   
drop table #Data;